DEFINE VARIABLE hDoc AS HANDLE.
DEFINE VARIABLE hRoot AS HANDLE.
DEFINE VARIABLE hNode1 AS HANDLE.
DEFINE VARIABLE hNode2 AS HANDLE.
DEFINE VARIABLE hNode3 AS HANDLE.
CREATE X-DOCUMENT hDoc.
CREATE X-NODEREF hRoot.
CREATE X-NODEREF hNode1.
CREATE X-NODEREF hNode2.
CREATE X-NODEREF hNode3.

/*set up a root node*/
hDoc:create-node(hRoot,"root","ELEMENT").
/*hRoot:name="root".*//* set name is readonly*/

if not hDoc:append-child(hRoot) then message "error append node".
if hDoc:num-children <> 1 then message "error append node".

if not hDoc:name <> "root" then message "error setter name for node".

hDoc:create-node(hNode1,"node1","ELEMENT").
hDoc:create-node(hNode2,"node2","ELEMENT").

if not hRoot:append-child(hNode1) then message "error append node".
if not hRoot:append-child(hNode2) then message "error append node".

if hRoot:num-children <> 2 then message "error append node".

if not hRoot:remove-child(hNode1) then message "error remove node".
if hRoot:num-children <> 1 then message "error remove node".

if not valid-handle(hNode1) then message "error remove node".
if not hRoot:append-child(hNode1) then message "error append deleted node".
if hRoot:num-children <> 2 then message "error append node".

if not hRoot:get-child(hNode3, 2) then message "error get node".

if hNode1:name <> hNode3:name then message "error get node".

hDoc:get-document-element(hNode3).

if hRoot:name <> hNode3:name then message "error get node".

/*create-node-namespace*/

if not hDoc:create-node-namespace(hNode3,"", "node3:Asd","ELEMENT")
      then message "error create-node-namespace node".

if hNode3:name <> "node3" then message "error create-node-namespace node".


hDoc:SAVE("file","test_xml.xml").

/*
DELETE OBJECT hDoc.
DELETE OBJECT hRoot.
DELETE OBJECT hNode1.
DELETE OBJECT hNode2.
DELETE OBJECT hNode3.
*/